if [namespace exists Cmd::Edit] return

# TreẽACe̕ҏW

namespace eval Cmd {
	namespace eval Edit {
	}
}

proc Cmd::Edit::buildMenu {parent} {
	set m $parent.edit 
	if {[winfo exists $m]} { return $m }
	menu $m -tearoff 0

	$m add command -label `FbN𔽓]  -command "Cmd::Edit::check inv"
	$m add command -label RgҏW... -command "Cmd::Edit::editComment ::doc"
	$m add separator 
	$m add command -label URLRs[     -command "Cmd::Edit::copyUrl"
	$m add command -label uEUŊJ  -command "Cmd::Edit::openWithBrowser"
	$m add separator
	$m add command -label 폜            -command "Cmd::Edit::delete"
	return $m
}

# `FbN𔽓]
proc Cmd::Edit::check {check} {
	set item [lindex [::Tree::getSelection] 0]
	if {$item eq ""} return
	Tree::checkItem $item inv
}
# Rg̕ҏW
proc Cmd::Edit::editComment {docName} {
	variable win
	upvar $docName doc

	set item [lindex [::Tree::getSelection] 0]
	if {$item eq ""} return

	foreach {check status title url comment date} [::Tree::getItemData $item] break
	
	Prompt::show "^OERgҏW" "$title\n$url\n[clock format $date -format %c]" $comment
	if {$Prompt::result ne "ok"} return
	if {$Prompt::str eq $comment} return
	set comment $Prompt::str
	Tree::updateItem $item $check edit $title $url $comment $date
	
	# Dom tree̍XV
	foreach {taglist comment} \
	[Hatena::Bookmark::getTagComment $comment] break

	set feed [$doc firstChild]
	set xmlns [$feed @xmlns:dc]
	foreach n [$feed getElementsByTagName entry] {
		set eurl ""
		foreach ln [$n getElementsByTagName "link"] {
			if {[$ln @rel] eq "related"} { set eurl [$ln @href]; break }
		}
		if {$eurl ne $url} continue

		# comment
		set sum [$n getElementsByTagName summary]
		if {[$sum hasChildNodes]} {
			[$sum firstChild] delete
		}
		if {$comment ne ""} {
			$sum appendChild [$doc createTextNode $comment]
		}
		
		# tag
		foreach {dsub} [$n getElementsByTagName dc:subject] {
			$dsub delete
		}
		foreach tag $taglist {
			set new [$doc createElementNS $xmlns "dc:subject"]
			$new appendChild [$doc createTextNode $tag]
			$n appendChild $new
		}
		break
	}
}
# IurlԂ
proc Cmd::Edit::_geturl {} {
	set item [lindex [::Tree::getSelection] 0]
	if {$item eq ""} return
	foreach {check status title url comment date} \
		[::Tree::getItemData $item] break
	return $url
}
# URLNbv{[hɃRs[
proc Cmd::Edit::copyUrl {} {
	clipboard clear
	clipboard append [_geturl]
}
# uEUŊJ
proc Cmd::Edit::openWithBrowser {} {
	switch -- $::tcl_platform(platform) {
		windows {
			eval "exec [auto_execok start] [string map {& ^&} [_geturl]] &"
		}
		unix {
			exec firefox [_geturl] &
		}
	}
}
# I폜
proc Cmd::Edit::delete {} {
		set item [lindex [::Tree::getSelection] 0]
		if {$item eq ""} return
		::_removeEntry $item
}
