if [namespace exists Cmd::Hatena] return

namespace eval Cmd {
	namespace eval Hatena {}
}

proc Cmd::Hatena::buildMenu {parent} {
	set m [menu $parent.hatena -tearoff 0]
	set ns "Cmd::Hatena"
	$m add command -label ͂ĂȃubN}[Nɐڑ -command ${ns}::connect
	$m add command -label ͂ĂȃubN}[Nؒf -command ${ns}::disconnect
	$m add separator
	$m add command -label Xg擾 -command "${ns}::getList2 ::doc ::htag"
	$m add command -label XgXV -command "${ns}::updateItem"
	$m add command -label Xg폜 -command "${ns}::deleteItem"
	return $m
}


# ͂ĂȂɐڑ
proc Cmd::Hatena::connect {} {
	Login::show
	if {$Login::result ne "ok"} return
	set Hatena::user $Login::user
	set Hatena::pass $Login::pass

	if {[catch {Hatena::Bookmark::connect} msg]} {
		set Hatena::user ""
		set Hatena::pass ""
		_toggleHatenaToolbutton off
		tk_messageBox -message Error:$msg
		return
	}
	_toggleHatenaToolbutton on
}
# ͂ĂȂؒf
proc Cmd::Hatena::disconnect {} {
	set Hatena::user ""
	set Hatena::pass ""
	_toggleHatenaToolbutton off
}

# urlłɓo^Ăׂ̂B
# o^ς݂ȂeidԂAo^ĂȂꍇ͋󕶎ԂB
proc Cmd::Hatena::_getRegisterdEid {url} {
	set doc [Hatena::Bookmark::getEntryFromUrl $url]
	set eid [Hatena::getEid [[$doc getElementsByTagName id] text]]

	if { ![[$doc getElementsByTagName issued] hasChild] } {
		set eid ""
	}
	$doc delete
	return $eid
}

# ͂ĂȂSGgǂݍ
proc Cmd::Hatena::getList {docName htagName} {
	upvar $docName doc
	upvar $htagName htag

	if {$doc ne "" && [::Tree::length] > 0} {
		set r [tk_messageBox -type okcancel \
		-message "܊JĂ郊Xgɏ㏑ĂłH"]
		if {$r eq "cancel"} return
		$doc delete;
	}
	set doc ""
	
	# ͂ĂȂɐڑđSGg̎擾
	Progress::show "ubN}[N̎擾..."
	Progress::update 0 10 0 "_E[hJn܂..."
	if {[catch {Hatena::Bookmark::feedAll $htag ::Progress::callback} ret]} {
		return Error:$ret
	}

	Progress::update 0 10 10 "hLgč\złEEE"
	set doc $ret
	::Tree::rebuild $doc

	Progress::update 0 10 10 "܂B"
	Progress::hide
	update

	return
}
# ͂ĂȂSGgǂݍ. _CAOJă^OXgQbg
proc Cmd::Hatena::getList2 {docName htagName} {
	upvar $htagName htag
	Prompt::show \
	"͂ĂȃubN}[ÑXg擾" \
	"擾^O͂ĂB\n^O̓Xy[Xŋ؂ĕ͂邱Ƃo܂B" $htag
	if {$Prompt::result ne "ok"} return
	set htag $Prompt::str
	Cmd::Hatena::getList $docName $htagName
}

# ͂ĂȃubN}[NXV
# ɃGgꍇ̓T}㏑
# GgȂꍇ͐VKo^
proc Cmd::Hatena::updateItem {} {

	set total [::Tree::length]
	Progress::show "͂ĂȃubN}[N̍XV..."
	Progress::update 0 $total 0 "o^EXVJn܂...\n\n"

	set i 1
	set item [::Tree::getFirst]
	while {$item ne ""} {
		foreach {chk status title url summary time} [::Tree::getItemData $item] break
		if {$chk != 1} {set item [::Tree::getNext $item]; continue}

		# łɃGgo^ςׂ݂āAXVVKo^B
		set reid [_getRegisterdEid $url]
		if {$reid ne ""} {
			# XV
			if {[catch {Hatena::Bookmark::putEntry $reid $summary} ret]} {
				::Tree::changeItemStatus $item error
				dputs "XVsF$data"
			} else {
				::Tree::changeItemStatus $item update
			}
		} else {
			# VKo^
			if {[catch {Hatena::Bookmark::postEntry $url $summary} data]} {
				::Tree::changeItemStatus $item error
				dputs "VKo^sF$data"
			} else {
				# TODO: eidXVׂǂlB
				$data delete
				::Tree::changeItemStatus $item new
			}
		}

		if {[Progress::callback 0 $total $i "$title\n$url\n$summary"] == 1} {
			break
		}
		incr i
		set item [::Tree::getNext $item]
#        after $::waitms
		::Util::timer $::waitms ::Progress::result
	}

	Progress::update 0 $total $total "܂B\n\n"
	Progress::hide
	return
}

# ubN}[N폜
proc Cmd::Hatena::deleteItem {} {

	set total [::Tree::length]
	Progress::show "ubN}[N̍폜..."
	Progress::update 0 $total 0 "폜Jn܂...\n\n"

	set i 1
	set item [::Tree::getFirst]
	while {$item ne ""} {
		foreach {chk status title url summary time} [::Tree::getItemData $item] break
		if {$chk != 1} {set item [::Tree::getNext $item]; continue}
		set reid [Cmd::Hatena::_getRegisterdEid $url]

		if {$reid ne ""} {
			if {[catch {Hatena::Bookmark::deleteEntry $reid} ret]} {
				::Tree::changeItemStatus $item error
			}
			::Tree::changeItemStatus $item delete
		} else {
			::Tree::changeItemStatus $item notfound
		}

		if {[Progress::callback 0 $total $i "$title\n$url\n$summary"] == 1} {
			break
		}
		incr i
		set item [::Tree::getNext $item]
#        after $::waitms
		::Util::timer $::waitms ::Progress::result
	}
	Progress::update 0 $total $total "܂B\n\n"
	Progress::hide
}
