if [namespace exists Cmd::Help] return

namespace eval Cmd {
	namespace eval Help {}
}

proc Cmd::Help::buildMenu {parent} {
	set m [menu $parent.help -tearoff 0]
	$m add command -label o[W... -command Cmd::Help::showVersion
	return $m
}

proc Cmd::Help::showVersion {} {
	if ![winfo exists .version] {
		toplevel .version
		set closeAction "grab release .version; wm withdraw .version"
		wm protocol .version WM_DELETE_WINDOW $closeAction

		set fp [open $::app(root)/License r]
		fconfigure $fp -encoding utf-8 -translation lf
		set licenseTerm [read $fp]
		close $fp
		set appname "$::app(name) $::app(version)"
		set w [ttk::frame .version.f]
		ttk::label $w.name -text $appname -font {{Arial} 50 bold} -foreground #000000
		text $w.license -relief flat -bg [style configure . -background] \
			-height 10 -yscrollcommand "$w.y set"
		ttk::scrollbar $w.y -orient vertical -command "$w.license yview"
		ttk::button $w.ok -text  -command $closeAction
		Util::bindMouseEvent $w.ok

		pack $w.name -side top
		pack $w.ok   -side bottom -pady 10
		pack $w.y -side right -fill y
		pack $w.license -side left -fill both
		pack $w
		$w.license delete 0.0 end
		$w.license insert 0.0 $licenseTerm
		$w.license configure -state disabled

		# FςV
		$w.y configure -command \
		"foreach {_n0 _n1} \[$w.y get\] break
		set _r \[expr {int(\$_n1 * 255)}\];
		set _g \[expr {int(\$_n1 * 255)}\];
		set _b \[expr {int(\$_n1 * 255)}\];
		$w.name configure -foreground \[format #%02x%02x%02x \$_r \$_g \$_b\]
		$w.license yview"

		wm resizable .version 0 0
		wm withdraw .version
	}
	Util::moveCenter .version
	wm transient .version .
	wm deiconify .version
	focus -force .version
	grab set .version
}
