if [namespace exists Hatena] return

package require base64
package require sha1
package require tdom

source utility.tcl

namespace eval Hatena {
	set user  ""
	set pass  ""
}

#=============================================================
# Tool
#=============================================================

# IDiFtag:hatena.ne.jp,2005-2006:bookmark-stripped-2164j
# ubN}[N(ʁHjeidԂBeid=entry_id̗?
proc Hatena::getEid {id} {
	return [lindex [split $id -] end]
}

#=============================================================
# Network
#=============================================================
proc Hatena::_passdigest {nonce date pass} {
	return [base64::encode [sha1::sha1 -bin $nonce$date$pass]]
}

proc Hatena::_wsse {} {
	variable user
	variable pass
	set user [string trim $user]
	#nonce̓NCAgKȕ
	set nonce [sha1::sha1 -hex [clock clicks]]
	set date  [clock format [clock seconds] \
			-format {%Y-%m-%dT%H%:%M:%SZ} -gmt 1]
	
	set ret "UsernameToken "
	append ret "Username=\"$user\", "
	append ret "PasswordDigest=\"[_passdigest $nonce $date $pass]\", "
	append ret "Nonce=\"[base64::encode $nonce]\", "
	append ret "Created=\"$date\""
	return $ret
}


#hatena.tclpɃJX^\bh𑗐Mł悤ɉhttp
source http2.tcl

# dataName̕ϐɎ擾f[^BԂl̓R[h
proc Hatena::atom {url request postdata dataName} {
	upvar $dataName data
	set tok [http::geturl $url \
		-method $request \
		-query [encoding convertto utf-8 $postdata] \
		-headers [list X-WSSE [_wsse]] \
		-timeout 5000]

	if {$::debug} {
		parray $tok
	}

	set data [encoding convertfrom utf-8 [http::data $tok]]
	set ncode [http::ncode $tok]
	http::cleanup $tok
	return $ncode
}

# TclCurlpR[h
#proc Hatena::atom {url request postdata dataName} {
#    upvar $dataName data
#    curl::transfer \
#        -url $url \
#        -customrequest $request \
#        -httpheader [list X-WSSE:[_wsse]] \
#        -postfields $postdata \
#        -timeout 15 \
#        -connecttimeout 10 \
#        -headervar header \
#        -bodyvar data \
#        -verbose 1 \
#        -errorbuffer errorvar
#    set data [encoding convertfrom utf-8 $data]
#    return [lindex $header(http) 1]
#}

