#!/bin/sh
# vim: set ts=4 fdm=marker fmr=<<<,>>> cms=;#%s:
# the next line restarts using wish \
exec wish "$0" ${1+"$@"}

#͂ĂȃubN}[ÑC|[g/GNX|[g

#TODO
if 0 {
Firefox̎荞
e[uXg̉ENbNɂ鑀߂
e[uXg̉ENbN
word,dateł̌ɂΉ
[] e[uXg̃\[gDOMc[ɂf邩ǂ߂BfȂ
}

package require tdom
package require Tk
package require tile
package require tkpng
package require treectrl

source utility.tcl
source image.tcl
source hatena_bookmark.tcl
source tooltip.tcl
source progress.tcl
source prompt.tcl
source login.tcl
#=============================================================
# Globals
#=============================================================
proc _init {appName} {
	upvar $appName app
	set app(name)    hbmark
	set app(version) 0.3

	#VFSł̂̃XNvg̈ʒu
	set app(root)    [pwd];
	
	# [U[猩ꍇ̎sʒu
	if {[info vars ::starkit::topdir] ne ""} {
	set app(rroot)   [file normalize [file dir $::starkit::topdir]]
	} else {
	set app(rroot)   [file normalize [file dir [info script]]]
	}

	# ݒt@CΓǂݍށB
	set ini [file join $app(rroot) hbmark.ini]
	if {[file exists $ini]} {
		set fp [open $ini r]
		while {![eof $fp]} {
			foreach {key val} [list {} {}] break
			foreach {key val} [gets $fp] break
			switch -- $key {
			}
		}
		close $fp
	}
}

array set app {}
_init app

set debug  1
set doc    {}   ;#DOM Tree
set htag   {}   ;#͂ĂȂ_E[h^ÕXgB
set waitms 1000 ;#[vŐڑƂ̃X[vb
#tile::setTheme clam
#tile::setTheme step
#=============================================================
# GUI Look & Feel
#=============================================================
switch -exact -- [tk windowingsystem] {
	x11 {
		style theme use clam
		font configure TkHeadingFont -weight normal
		option add *Menu.activeBackground $tile::colors(-selectbg)
		option add *Menu.activeForeground $tile::colors(-selectfg)
		option add *Menu.font  TkTextFont
		option add *Label.font TkTextFont
		option add *Listbox.font TkTextFont
		option add *Menu.activeBorderWidth 0
		option add *Menu.borderWidth 1
		option add *.cursor {}
	}
}
switch -exact -- $tile::currentTheme {
	aqua {
		rename ttk::scrollbar ttk::_scrollbar
		rename scrollbar ttk::scrollbar
	}
}

option add *Label.background [style configure . -background]
option add *Text.selectBackground $tile::colors(-selectbg)

style configure Toolbutton -padding 1
#=============================================================
# Debug Print
#=============================================================
if {$debug == 1} {
	proc dputs args {
		::puts "[info level [expr {[info level] - 1}]] : $args"
	}
} else {
	proc dputs args {}
}

#=============================================================
# Commands
#=============================================================
proc _toggleHatenaToolbutton {state} {
	switch -- $state {
	on {
		.tbar.conOn    configure -state disabled
		.tbar.conOff   configure -state normal
		.tbar.tag      configure -state normal
		.tbar.gethlist configure -state normal
		.tbar.hmodify  configure -state normal
		.tbar.hdelete  configure -state normal
	}
	off {
		.tbar.conOn    configure -state normal
		.tbar.conOff   configure -state disabled
		.tbar.tag      configure -state disabled
		.tbar.gethlist configure -state disabled
		.tbar.hmodify  configure -state disabled
		.tbar.hdelete  configure -state disabled
	}
	}
}

#=============================================================
# Tree
#=============================================================
namespace eval Tree {
	variable win ""
	variable sortcol 0
	array set color {
		itembg #EEEEEE
	}
}
# c[Xg̐
proc Tree::build {parent} {
	variable win
	variable color
	if ![winfo exists $win] {
		set win $parent.tree
		treectrl $win -highlightthickness 0 \
		-usetheme 1 -columnresizemode realtime \
		-background white -font [style configure . -font]

		set height [font metrics [$win cget -font] -linespace]
		if {$height < 16} {
			set height 16
		}
		$win configure -itemheight $height -showlines 1 -showroot 0

		set colbg [style configure . -background]
		$win column create -width 40  -tag check   -text CHK
		$win column create -width 40  -tag status  -text 
		$win column create -width 175 -tag title   -text ^Cg
		$win column create -width 175 -tag url     -text URL
		$win column create -width 175 -tag comment -text Rg
		$win column create -width 110 -tag date -text t
		$win column configure all -background $colbg \
			-itembackground [list $color(itembg) {}]
		
		$win state define check
		$win state define on
		$win state define off

		$win state define status
		$win state define normal  
		$win state define edit    
		$win state define new     
		$win state define update  
		$win state define delete  
		$win state define notfound
		$win state define error   
		$win state define default 
		
		set tcolbg  [style configure . -background]
		set tcolfg  [style configure . -foreground]
		set tcolsbg [style configure . -selectbackground]
		set tcolsfg [style configure . -selectforeground]
		set colbg [list $tcolsbg {selected focus} $tcolbg {selected}]
		set colfg [list $tcolsfg {selected focus} $tcolfg {selected}]
		
		$win element create eborder rect -open nse -outline gray -outlinewidth 1
		$win element create erect rect -fill $colbg
		$win element create etext text -fill $colfg -lines 1
		$win element create etime text -fill $colfg -lines 1 -datatype time -format "%Y-%m-%d %T"
		$win element create eimage-check image -image {
			Image::unchecked {check off}
			Image::checked   {check on}
		}
		$win element create eimage-status image -image {
			Image::stNormal  {status normal}
			Image::stEdit    {status edit}
			Image::stNew     {status new}
			Image::stUpdate  {status update}
			Image::stDelete  {status delete}
			Image::stNFound  {status notfound}
			Image::stError   {status error}
		}
		
		$win style create styleCheck
		$win style create styleStatus
		$win style create styleText
		$win style create styleTime

		$win style elements styleCheck  {eborder erect etext eimage-check}
		$win style elements styleStatus {eborder erect etext eimage-status}
		$win style elements styleText   {eborder erect etext}
		$win style elements styleTime   {eborder erect etime}
		
		$win style layout styleCheck  etext -height 0 -width 0
		$win style layout styleStatus etext -height 0 -width 0
		$win style layout styleCheck  eimage-check  -expand news
		$win style layout styleStatus eimage-status -expand news
		$win style layout styleText   etext -squeeze x -expand ns
		$win style layout styleTime   etime -squeeze x -expand ns

		$win style layout styleCheck  erect -union eimage-check  -iexpand news
		$win style layout styleStatus erect -union eimage-status -iexpand news
		$win style layout styleText   erect -union etext -iexpand news -ipadx {5 5}
		$win style layout styleTime   erect -union etime -iexpand news -ipadx {5 5}

		$win style layout styleCheck  eborder -iexpand xy -detach yes
		$win style layout styleStatus eborder -iexpand xy -detach yes
		$win style layout styleText   eborder -iexpand xy -detach yes
		$win style layout styleTime   eborder -iexpand xy -detach yes

		$win configure -defaultstyle \
		[list styleCheck styleStatus styleText styleText styleText styleTime]
	}

	$win notify install <Header-invoke>
	$win notify bind $win <Header-invoke> { Tree::sort %T %C }
	bind $win <3> [namespace code {
		set _info [$win identify %x %y]
		if {[lindex $_info 0] eq "item"} {
			set _item [lindex $_info 1]
			$win selection clear
			$win selection add $_item
			$win activate $_item
			unset _item
		}
		unset _info
	}]
	return $win
}
proc Tree::bindPopMenu {pop} {
	variable win
	bind $win <3> "+ tk_popup $pop %X %Y"
}

# ACe̒ǉ
proc Tree::addItem {check status title url comment date} {
	variable win
	set item [$win item create]
	
	$win item text $item \
		 check    $check   \
		 status   $status  \
		 title    $title   \
		 url      $url     \
		 comment  $comment
	$win item element configure $item date etime -data $date

	checkItem $item $check
	changeItemStatus $item $status
	
	$win item lastchild root $item
	return $item
}
# ACẽf[^̎擾
proc Tree::getItemData {item} {
	variable win

	foreach {check status title url comment date} [$win item text $item] break
	set date [$win item element cget $item date etime -data]
	
	set check [isChecked $item]
	foreach type { normal edit new update delete notfound error default } {
		if {[$win item state get $item $type]} {
			set status $type
			break
		}
	}
	return [list $check $status $title $url $comment $date]
}
# ACe̍XV
proc Tree::updateItem {item check status title url comment date} {
	variable win
	
	$win item text $item \
		 check    $check   \
		 status   $status  \
		 title    $title   \
		 url      $url     \
		 comment  $comment
	$win item element configure $item date etime -data $date

	checkItem $item $check
	changeItemStatus $item $status

	return $item
}
# c[̃rh
proc Tree::rebuild {doc} {
	variable win
	if {$doc eq ""} {
		$win item delete 0 end
		return
	}

	$win item delete 0 end
	set feed [$doc firstChild]
	foreach n [$feed getElementsByTagName entry] {
		# title
		set title [[$n getElementsByTagName title] text]
		# url
		set url "unknown-url"
		foreach nn [$n getElementsByTagName link] {
			if {[$nn @rel] eq "related"} { set url [$nn @href] }
		}
		# comment
		set comment [Hatena::Bookmark::getCommentFromEntry $n]
		
		# date
		set time [[$n getElementsByTagName issued] text]
		set time [clock scan [string range $time 0 18]]
		addItem on normal $title $url $comment $time
	}
}
# `FbNO, status=on, off, inv
proc Tree::checkItem {item status} {
	variable win

	set st off
	switch -- $status {
		1   {set st on}
		0   {set st off}
		on  {set st on}
		off {set st off}
		inv {
			if ![$win item state get $item off] {
				set st off
			} else {
				set st on
			}
		}
	}
	$win item state set $item [list !off !on check $st]
	$win item text $item check $st
}
# `FbNĂ邩ǂ
proc Tree::isChecked {item} {
	variable win
	return [$win item state get $item on]
}
# e[uXg̍ŏIXe[^X̍XV
# normal  ʂ̏ԁBubN}[N̎擾At@CJ
# edit    Rg^OҏW
# new     ͂ĂȃubN}[NɐVKo^
# update  ͂ĂȃubN}[NŊɓo^Ă̃RgE^Oς
# delete  ͂ĂȃubN}[Nɓo^Ă̂
# error   ̃G[NBiʐMؒfȂǁj
# default ̑Bs\ȃXe[^XnꂽꍇB
proc Tree::changeItemStatus {item status} {
	variable win
	set st {status !normal !edit !new !update 
		!delete !notfound !error !default}
	
	switch -- $status {
		normal   { lappend st $status }
		edit     { lappend st $status }
		new      { lappend st $status }
		update   { lappend st $status }
		delete   { lappend st $status }
		notfound { lappend st $status }
		error    { lappend st $status }
		default  { set status default; lappend st default }
	}
	$win item state set $item $st
	$win item text $item status $status
}
proc Tree::getStatus {item} {
	variable win
	return [$win item text $item status]
}
# Tree namespace܂ɌĂ΂\̂
# s{ӂȂImage𒼐ږߍ
proc Tree::getStatusImage {status} {
	switch -- $status {
		normal   { return Image::stNormal }
		edit     { return Image::stEdit   }
		new      { return Image::stNew    }
		update   { return Image::stUpdate }
		delete   { return Image::stDelete }
		notfound { return Image::stNFound }
		error    { return Image::stError  }
		default  { return "" }
	}
	return ""
}

#̑ACe
proc Tree::length {} {
	variable win
	return [$win item numchildren root]
}
proc Tree::getFirst {} {
	variable win
	return [$win item firstchild root] 
}

proc Tree::getNext {item} {
	variable win
	return [$win item nextsibling $item]
}

proc Tree::getAll {} {
	variable win
	return [$win item children root]
}

proc Tree::getSelection {} {
	variable win
	return [$win selection get]
}

proc Tree::delete {itemlist} {;#<<<
	variable win
	if {[llength $itemlist] == 0} return

	foreach item $itemlist {
		set next [$win item nextsibling $item]
		$win item delete $item
		$win selection clear
		if {$next ne ""} {
			$win selection add $next
			$win activate $next
		}
	}
};#>>>

proc Tree::getTag {id} {
	variable win
	return [$win column cget $id -tag]
}

# wb_NbNꂽ̃\[g̃oCfBO
proc Tree::sort {tree col} {;#<<<
	variable win
	variable sortcol

	# Sort order
	if {[$win column compare $col == $sortcol]} {
		if {[$win column cget $col -arrow] eq "down"} {
			set order -increasing
			set arrow up
		} else {
			set order -decreasing
			set arrow down
		}
	} else {
		set order -increasing
		set arrow up
		$win column configure $sortcol -arrow none 
		set sortcol $col
	}
	# sort
	$win item sort root $order -column $col -dictionary
	$win column configure $col -arrow $arrow
};#>>>


# e[uc[DOMc[̗ACe폜鏈B
proc _removeEntry {itemlist} {
	if {$::doc eq ""} return
	if {[llength $itemlist] == 0} return
	dputs $itemlist

	set feed [$::doc firstChild]
	foreach item $itemlist {
		foreach {chk status title url summary date} [::Tree::getItemData $item] break
		foreach n [$feed getElementsByTagName "entry"] {
			set durl "unknown-url"
			foreach nn [$n getElementsByTagName link] {
				if {[$nn @rel] eq "related"} { set durl [$nn @href] }
			}
			if {$durl eq $url} {
				$n delete; break
			}
		}
	}
	::Tree::delete $itemlist
}


#=============================================================
# ȉGUI̍쐬ƃCvV[W
#=============================================================
Tooltip::init


#=============================================================
# CEBhE
#=============================================================
source cmd_file.tcl
source cmd_edit.tcl
source cmd_listedit.tcl
source cmd_hatena.tcl
source cmd_help.tcl

proc makeMainDialog {} {
	# j[
	menu .mbar -border 0
	.mbar add cascade -label t@C   -menu [Cmd::File::buildMenu   .mbar]
	.mbar add cascade -label ҏW       -menu [Cmd::Edit::buildMenu   .mbar]
	.mbar add cascade -label XgҏW -menu [Cmd::ListEdit::buildMenu   .mbar]
	.mbar add cascade -label ͂Ă     -menu [Cmd::Hatena::buildMenu .mbar]
	.mbar add cascade -label wv     -menu [Cmd::Help::buildMenu   .mbar]
	. configure -menu .mbar

	# c[o[
	ttk::frame .tbar -relief groove -borderwidth 0
	proc _mktbtn {name img cmd text} {
		ttk::button .tbar.$name -style Toolbutton \
		-image $img -command $cmd
		Tooltip::bindWin .tbar.$name $text
	}
	_mktbtn save   Image::save   {Cmd::File::save ::doc} ۑ
	_mktbtn load   Image::open   {Cmd::File::open ::doc} t@CJ
	ttk::separator .tbar.sep0 -orient vertical
	_mktbtn conOn  Image::conOn  Cmd::Hatena::connect    ͂ĂȃubN}[Nɐڑ
	_mktbtn conOff Image::conOff Cmd::Hatena::disconnect ͂ĂȃubN}[Nؒf
	ttk::separator .tbar.sep1 -orient vertical
	ttk::entry     .tbar.tag -textvariable ::htag
	bind .tbar.tag <Return> "Cmd::Hatena::getList ::doc ::htag"
	Util::bindEditorPopCommon .tbar.tag
	_mktbtn gethlist Image::down "Cmd::Hatena::getList ::doc ::htag" "͂ĂBubN}[ÑXg擾B\ñeLXg{bNXɎ擾^ÕXg͂ĂB"
	ttk::separator .tbar.sep2 -orient vertical
	_mktbtn hmodify Image::up     "Cmd::Hatena::updateItem" ͂ĂBXV
	_mktbtn hdelete Image::delete "Cmd::Hatena::deleteItem" ͂ĂB폜
	rename _mktbtn ""
	eval pack [winfo children .tbar] -side left -padx 2 -pady 2 -fill y -expand no
	pack .tbar -fill x
	
	# c[
	ttk::frame .t
	set tree [Tree::build .t]
	$tree configure -yscrollcommand ".t.y set" -xscrollcommand ".t.x set" 
	ttk::scrollbar .t.x -orient horizontal -command "$tree xview"
	ttk::scrollbar .t.y -orient vertical   -command "$tree yview"

	grid $tree -row 0 -column 0 -sticky news
	grid .t.y    -row 0 -column 1 -sticky ns
	grid .t.x    -row 1 -column 0 -sticky ew
	grid columnconfigure .t 0 -weight 1 
	grid rowconfigure    .t 0 -weight 1 
	pack .t -fill both -expand yes
	wm geometry . 740x350
	
	Tree::bindPopMenu [Cmd::Edit::buildMenu .mbar]

#    bind . <MouseWheel> {
#        if { ![string match .t.* [winfo containing %X %Y]] } return
#        .t.tree yview scroll [expr {- (%D / 120) * 4}] units
#    }
	bind $tree <1> {
		set _info [%W identify %x %y]
		if {[lindex $_info 0] eq "item"} {
			if {[Tree::getTag [lindex $_info 3]] eq "check"} {
				Tree::checkItem [lindex $_info 1] inv
			}
		}
		unset _info
	}
	bind $tree <Double-1> {
		set _info [%W identify %x %y]
		if {[lindex $_info 0] eq "item"} {
			switch -- [Tree::getTag [lindex $_info 3]] {
				url     {Cmd::Edit::openWithBrowser}
				comment {Cmd::Edit::editComment ::doc}
				default {}
			}
		}
		unset _info
	}
	bind . <space> {
		if { ![string match .t.* [focus]] } return
		set item [Tree::getSelection]
		Tree::checkItem $item inv
	}
	bind . <Delete> {
		Cmd::Edit::delete
	}
	bind . <BackSpace> { event generate . <Delete> }
}

proc main {} {
	makeMainDialog
	Cmd::Hatena::disconnect
	focus -force .
}
main
