if [namespace exists Progress] return

#=============================================================
# vOXo[_CAO
#=============================================================
namespace eval Progress {
	variable result ""
}

proc Progress::show {{title "..."}} {
	variable result
	set result ""
	if ![winfo exists .progress] {
		toplevel .progress
		set cancelAction "grab release .progress; wm withdraw .progress"
		wm protocol .progress WM_DELETE_WINDOW \
			"$cancelAction;set Progress::result cancel"
		ttk::frame .progress.f -borderwidth 5
		set w .progress.f
		label $w.info -width 10 -anchor w -justify left -wraplength -1 \
		-text "ł..."
		ttk::progressbar $w.prog -length 400
		ttk::button $w.cancel -text LZ \
			-command "$cancelAction; set Progress::result cancel"
		Util::bindMouseEvent $w.cancel
		pack $w.info -expand no -fill x
		pack $w.prog -expand yes -fill x -pady 10
		pack $w.cancel
		pack $w
		wm resizable .progress 0 0
		wm withdraw .progress
	}
	wm title .progress $title
	Util::moveCenter .progress
	wm transient .progress .
	wm deiconify .progress
	focus -force .progress
	grab set .progress
#    tkwait variable Progress::result
#    return $Progress::result
}

proc Progress::update {min max idx {str "ł..."}} {
	set idx [expr {$idx-$min}]
	set max [expr {$max-$min}]
	.progress.f.info configure -text $str
	.progress.f.prog configure -value $idx -maximum $max
	::update
}

# R[obNBLZꂽ1ԂB
proc Progress::callback {min max cur str} {
	Progress::update $min $max $cur $str
	dputs "min=$min max=$max cur=$cur str=$str"
	return [expr {$Progress::result eq "cancel"}]
}

proc Progress::hide {} {
	variable result
	grab release .progress
	wm withdraw .progress
	set result ok
}

