if [namespace exists Prompt] return

#=============================================================
# ̓{bNX_CAO
#=============================================================
namespace eval Prompt {
	variable result ""
	variable str    ""
}

proc Prompt::show { {title "̓_CAO"} {msg "͂Ă"} {default ""} } {
	variable result
	variable str
	set result ""

	if ![winfo exists .prompt] {
		toplevel .prompt
		set closeAction "grab release .prompt; wm withdraw .prompt"
		wm protocol .prompt WM_DELETE_WINDOW \
			"$closeAction;set Prompt::result cancel"
		ttk::frame .prompt.f -borderwidth 5
		set w .prompt.f
		label $w.info -width 10 -anchor w -justify left -wraplength -1 \
		-text "͂Ă..."
		ttk::entry $w.entry -width 50 -textvariable Prompt::str
		Util::bindEditorPopCommon $w.entry
		ttk::button $w.ok -text OK \
			-command "$closeAction; set Prompt::result ok"
		ttk::button $w.cancel -text LZ \
			-command "$closeAction; set Prompt::result cancel"
		Util::bindMouseEvent $w.ok
		Util::bindMouseEvent $w.cancel

		grid $w.info  -columnspan 2 -sticky ew
		grid $w.entry -columnspan 2 -sticky ew -pady 10
		grid $w.ok     -column 0 -row 2 -sticky e -padx 2
		grid $w.cancel -column 1 -row 2 -sticky w -padx 2
		pack $w
		bind $w.entry <Return> {event generate .prompt <Tab>}
		bind .prompt  <Escape> "$closeAction; set Prompt::result cancel"

		wm resizable .prompt 0 0
		wm withdraw .prompt
	}
	.prompt.f.info configure -text $msg
	set str $default
	.prompt.f.entry selection range 0 end
	.prompt.f.entry icursor end
#pathName icursor index

	wm title .prompt $title
	Util::moveCenter .prompt
	wm transient .prompt .
	wm deiconify .prompt
	focus -force .prompt.f.entry
	grab set .prompt
	tkwait variable Prompt::result
	return $Prompt::result
}
