cd [file dir $argv0]
set mode [lindex $argv 0]
set name hbmark
cd ..;# move to rootdir
set rootdir [pwd]
set sdx C:/Tcl/bin/sdx.kit
set kit C:/Tcl/bin/tclkit-jp.exe
set ext .exe
if {$tcl_platform(platform) ne "windows"} {
	set ext ""
}



proc copy {file dir} {
	file copy $file $dir
	exec tclsh tool/to8bitclean.tcl < $file > [file join $dir $file]
}

proc copyimgs {} {
	file copy img hbmark.vfs
}

proc copylibs {} {
	file mkdir hbmark.vfs/lib
	set dest [file normalize hbmark.vfs/lib]
	set libdir [file dir [info library]]
	cd $libdir

	# tdom
	file copy [lindex [glob tdom0*] end] $dest
#    file copy [lindex [glob tnc*] end] $dest
	# Tcllib
	file copy [lindex [glob Trf2*] end] $dest
	file copy [lindex [glob tcllib_critcl*] end] $dest
	foreach name {base64 sha1} {
	file copy [lindex [glob tcllib1.*/$name] end] $dest
	}
	# tile
	file copy [lindex [glob tile*] end] $dest
	# tkpng
	file copy [lindex [glob tkpng*] end] $dest
	# treectrl
	file copy [lindex [glob treectrl*] end] $dest
}

file delete -force $name.vfs
file mkdir hbmark.vfs ; after 200
cd hbmark.vfs

set fp [open main.tcl w]
puts $fp {
package require starkit
starkit::startup
set _dir [pwd]
cd [file dir [info script]]
source hbmark.tcl
cd $_dir
unset _dir
}
close $fp

cd ..
file copy License hbmark.vfs
foreach file [glob *.tcl] { copy $file hbmark.vfs }
#foreach file [glob -nocomplain -- *.gif] { file copy $file hbmark.vfs }
#foreach file [glob -nocomplain -- *.png] { file copy $file hbmark.vfs }

copyimgs
switch -- $mode {
	lite {
		file delete -force $name.kit
	}

	all  {
		file delete -force $name.kit
		copylibs
	}

	standalone {
		file delete -force $name.exe
		copylibs
	}

	default {
		puts "wrong args"
		puts "    lite       : source only kit"
		puts "    all        : source + library kit"
		puts "    standalone : standalone exe"
		exit 1
	}
}


# wrap
cd $rootdir
if {$mode eq "standalone"} {
	exec tclsh $sdx wrap $name$ext -runtime $kit
} else {
	exec tclsh $sdx wrap ${name}.kit
}
exit

exit 0
